require 'drb'

class WNAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @wnbot = DRbObject.new(nil, 'druby://localhost:9040')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    response, score  = @wnbot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if response.to_s =~ /\(/ then score += 1 end
    if input =~ /^wn[(bot|agent)?][:, ]*/i then score += 2 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    puts "WNBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score])
  end
end
