require 'drb'

class ALICEAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @alice = DRbObject.new(nil, 'druby://localhost:9020')
  end

  def method_missing(input = "")
    input = input.to_s
    input.chomp!
    response = ''
    #score = rand(3) + 1
    response, score = @alice.getResponse(input.to_s) unless input =~ /\#/
    if score == nil then score = 4 end
    if response == '' or response == nil then score = 0 end
    puts "ALICE: #{response} | #{score}"  unless @callerObj.DEBUG == 0
    @callerObj.addResponse([response, score])
  end

end
