require 'drb'

class LinkAgent 

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @link = DRbObject.new(nil, 'druby://localhost:9050')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^link[:, ]*(.*)/ then input = $1.strip end  
    response = @link.getResponse(input)
    begin
      score = response.score 
    rescue 
      score = 1 
      if response.to_s =~ /Default response/ then score = 0 end
        if input =~ /(?:subject|object|verb)/ then score = 3 end
    end
    if input =~ /^link[:, ]*/ then score += 1 end
    puts "Link: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score])
  end

end
